package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.view.components.challenges.modals.*;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.utils.ArrayUtil;

import org.puremvc.as3.interfaces.INotification;

import starling.events.Event;

public class ChallengeLeaderBoardPopupMediator extends PopUpMediator {
    private var _proxy:ChallengesProxy;
    private var _leaderBoardPopup:ChallengeLeaderBoardPopup;
    public function ChallengeLeaderBoardPopupMediator(popUp:PopUp) {
        super(popUp);
        _leaderBoardPopup = popUp as ChallengeLeaderBoardPopup;
    }

    override public function onRegister():void {
        super.onRegister();
        _proxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
        _leaderBoardPopup.addEventListener(ChallengeEvent.REQUEST_LEADER_BOARD_DATA, leaderBoardRequestHandler);
        _leaderBoardPopup.addEventListener(ChallengeEvent.LEADER_BOARD_USER_SELECTED, leaderBoardUserSelectedHandler);
    }

    private function leaderBoardUserSelectedHandler(event:Event):void {
        if(_leaderBoardPopup.isLeaderBoard){
            sendNotification(Notifications.RELOAD_LEADER_BOARD_TUNING_LIST, event.data);
        }else{
            sendNotification(Notifications.DISPLAY_LEADER_BOARD_TUNING_LIST, event.data);
        }
    }

    override public function onRemove():void {
        super.onRemove();
        _leaderBoardPopup.removeEventListener(ChallengeEvent.REQUEST_LEADER_BOARD_DATA, leaderBoardRequestHandler);
    }

    private function leaderBoardRequestHandler(event:Event):void {
        _proxy.getLoaderBoardByPeriod(event.data.limit, event.data.skip, event.data.toDate, event.data.country, event.data.period, function (data:Object):void {
            _leaderBoardPopup.loadData(data as Array);
        });
    }

    /*private function leaderBoardRequestHandler(event:Event):void {
        _proxy.getLoaderBoardThisWeek(event.data.limit, event.data.skip, event.data.toDate, event.data.country, function (data:Object):void {
            _leaderBoardPopup.loadData(data as Array);
        });
    }*/

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [

        ]);
    }

    override public function handleNotification(note:INotification):void {
        switch(note.getName()) {

        }
        super.handleNotification(note);
    }
}
}
