package com.despark.tuning3d.view.components.challenges.modals {
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeLeaderBoardItemRenderer;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeTextItemRenderer;
import com.despark.tuning3d.view.components.challenges.controls.ChallengesLoadBar;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.gallery.GalleryLabelFactory;
import com.despark.tuning3d.view.components.gallery.data.RequestPeriod;
    import com.despark.tuning3d.view.components.gallery.data.RequestRegion;
    import com.distriqt.AdsManager;
    import com.utils.ObjectUtils;

import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.Radio;
import feathers.controls.ScrollPolicy;
import feathers.controls.ToggleButton;
import feathers.controls.renderers.IListItemRenderer;
import feathers.core.ToggleGroup;
import feathers.data.ListCollection;
import feathers.events.FeathersEventType;
import feathers.layout.AnchorLayoutData;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.HorizontalLayoutData;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import flash.geom.Rectangle;

import starling.core.Starling;

import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;
import starling.filters.DropShadowFilter;

public class ChallengeLeaderBoardPopup extends PopUp {
    private var _userList:List;
    private var _userIdList:Object;
    private var _titleLabel:Label;
    private var _topBanner:LayoutGroup;
    private var _flagIcon:Image;
    private var _headerBorder:Quad;
    private var _loadBar:ChallengesLoadBar;
    private var _requestCount:int;
    private var _toDate:Date;
    private var isLoading:Boolean = false;
    private var isLoaded:Boolean = false;
    private var _currentUser:User;
    public var isLeaderBoard:Boolean;
    //
    private var _showByButton:ToggleButton;
    private var _countryButton:ToggleButton;
    private var _worldButton:ToggleButton;


    private var _regionButtonGroup:LayoutGroup;
    private var regionGroup:ToggleGroup;
    private var regionBackground:Quad;
    public var countryData:Object;
    //
    private var showByBorderList:Array;
    private var showByGroup:LayoutGroup;
    private var showByMenu:Sprite;
    private var showByToggleGroup:ToggleGroup;
    private var showByLabel:Object;
    private var _period:String;
    private var leaderboardTopBg:Image;
    //
    private static const SCREEN_WIDTH:int = 280;
    //
    private var _showBannerAfterExit:Boolean;
    private var _bannerScreen:String;
    public function ChallengeLeaderBoardPopup(data:Object = null) {
        super();
        isLeaderBoard = false;
        _userIdList = {};
        _showBannerAfterExit = (data && data.hasOwnProperty("showBannerAfterExit") && data.showBannerAfterExit);
        _bannerScreen = (data && data.hasOwnProperty("bannerScreen"))?data["bannerScreen"]:BannerScreen.BANNER_SCREEN;
    }

    override protected function initialize():void {
        super.initialize();
        setSizeInternal(SCREEN_WIDTH, stage.stageHeight, false);
        //

        background.color = 0x000000;
        background.alpha = 0.8;
        contentBackgroundImage.visible = false;

        leaderboardTopBg = new Image(ButtonFactory.assetManager.getTexture("leaderboard_top_bg"));
        leaderboardTopBg.scale9Grid = new Rectangle(leaderboardTopBg.texture.frameWidth/2 - 0.5, leaderboardTopBg.texture.frameHeight, 1, 0);
        leaderboardTopBg.height = 20;
        leaderboardTopBg.width = actualWidth;
        addChild(leaderboardTopBg);


        _headerBorder = new Quad(1,1,0xFFFFFF);
        _headerBorder.width = actualWidth;
        var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
        _currentUser = usersProxy.currentUser;
        _topBanner = new LayoutGroup();
        _topBanner.setSize(actualWidth, 20);
        _headerBorder.y = _topBanner.height;
        var topBannerLD:AnchorLayoutData = new AnchorLayoutData();
        topBannerLD.right = topBannerLD.left = 5;
        topBannerLD.verticalCenter = 0;
        _topBanner.layoutData = topBannerLD;
        _titleLabel = new Label();
        _titleLabel.layoutData = new HorizontalLayoutData();
        _titleLabel.width = actualWidth;
        _titleLabel.height = 14;
        _titleLabel.textRendererFactory = ChallengeTextItemRenderer.titleFieldFactory;
        _titleLabel.text = "Challenge Leaderboard";
        _titleLabel.validate();
        _titleLabel.y = (_topBanner.height - _titleLabel.height)/2;
        _topBanner.addChild(_titleLabel);
        //
        regionBackground = new Quad(1, 1, 0xFFFFFF);
        regionBackground.width = SCREEN_WIDTH;
        regionBackground.height = 30;
        regionBackground.y = _topBanner.height;
        addChild(regionBackground);

        _regionButtonGroup = new LayoutGroup();
        _showByButton = ButtonFactory.createLeaderBoardRegionButton("gallery_clock", "showByTime", 0, true, false);
        _countryButton = ButtonFactory.createLeaderBoardRegionButton(String(countryData.country).toLowerCase(), RequestRegion.BY_COUNTRY, 14, false);
        _worldButton = ButtonFactory.createLeaderBoardRegionButton("timeline_world_icon", RequestRegion.BY_WORLD);

        _showByButton.label = "This week";
        _countryButton.label = "Country";
        _worldButton.label = "World";

        _showByButton.width = 100;
        _countryButton.width = 100;
        _worldButton.width = SCREEN_WIDTH - (_showByButton.width + _countryButton.width + 10);

        var regionLayout:HorizontalLayout = new HorizontalLayout();
        regionLayout.horizontalAlign = HorizontalAlign.LEFT;
        regionLayout.verticalAlign = VerticalAlign.MIDDLE;
        _regionButtonGroup.layout = regionLayout;
        _regionButtonGroup.addChild(_showByButton);
        _regionButtonGroup.addChild(_countryButton);
        _regionButtonGroup.addChild(_worldButton);
        _regionButtonGroup.height = regionBackground.height;
        _regionButtonGroup.y = _topBanner.height;
        _regionButtonGroup.width = actualWidth;
        addChild(_regionButtonGroup);

        regionGroup = new ToggleGroup();
        regionGroup.addItem(_worldButton);
        regionGroup.addItem(_countryButton);
        regionGroup.isSelectionRequired = true;
        regionGroup.addEventListener(Event.CHANGE, regionChangeHandler);



        var regionBoarder:Quad = new Quad(1, 1, 0xFFFFFF);
        regionBoarder.width = actualWidth;
        regionBoarder.y = _regionButtonGroup.y + _regionButtonGroup.height;
        addChild(regionBoarder);
        //
        //

        addChild(_topBanner);
        _userList = new List();
        _userList.isSelectable = true;
        _userList.setSize(actualWidth, actualHeight - _topBanner.height - _regionButtonGroup.height);
        _userList.y = _topBanner.height + _regionButtonGroup.height;
        _userList.horizontalScrollPolicy = ScrollPolicy.OFF;
        _userList.verticalScrollPolicy = ScrollPolicy.ON;
        _userList.dataProvider = new ListCollection([]);
        _userList.addEventListener(Event.CHANGE, selectionChangeHandler);
        _userList.addEventListener(Event.SCROLL, listScrollHandler);
        addChild(_userList);

        closeButton.setSize(20,20);
        closeButton.x = actualWidth - closeButton.width;
        closeButton.y = 0;
        addChild(closeButton);
        addChild(_headerBorder);

        _flagIcon = new Image(ButtonFactory.assetManager.getTexture("leaderboard_flag_icon"));
        _flagIcon.width = _flagIcon.height = 20;
        _flagIcon.color = 0xFFFFFE;
        addChild(_flagIcon);

        createShowBySection();

        _loadBar = new ChallengesLoadBar();
        _loadBar.setSize(actualWidth, _userList.height);
        _requestCount = Math.ceil(_userList.height/50);
        _userList.itemRendererFactory = leaderBoardItemFactory;
        requestData();
    }

    override protected function closeButtonTriggeredHandler(event:Event):void{
        super .closeButtonTriggeredHandler(event);
        if(_showBannerAfterExit){
            if(_bannerScreen == BannerScreen.BANNER_SCREEN){
                BannerStackedScreen.showAdBanner();
            }else if(_bannerScreen == BannerScreen.HOME_SCREEN){
                AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
            }
        }
    }

    private function regionChangeHandler(event:Event):void {
        _userList.dataProvider.removeAll();
        isLoaded = isLoading = false;
        _showByButton.isSelected = false;
        requestData();
    }

    private function listScrollHandler(event:Event):void {
        if(isLoading || isLoaded){
            return;
        }
        if(_userList.verticalScrollPosition>_userList.maxVerticalScrollPosition){
            requestData();
        }
    }

    private function selectionChangeHandler(event:Event):void {
        dispatchEvent(new Event(ChallengeEvent.LEADER_BOARD_USER_SELECTED, false, _userList.selectedItem));
    }

    override protected function draw():void {
        super.draw();
        //
        background.height = actualHeight - _topBanner.height;
        background.y = _topBanner.height;
        if(closeButton){
            closeButton.x = actualWidth - closeButton.width;
            closeButton.y = 0;
        }
    }

    private function leaderBoardItemFactory() : IListItemRenderer {
        var renderer : ChallengeLeaderBoardItemRenderer = new ChallengeLeaderBoardItemRenderer();
        renderer.setSize(actualWidth, 50);
        renderer.currentUser = _currentUser;
        return renderer;
    }

    public function requestData():void{
        if(!isLoading && !isLoaded) {
            _toDate ||= new Date();
            isLoading = true;
            _loadBar ||= new ChallengesLoadBar();
            _loadBar.x = _userList.x;
            _loadBar.y = _userList.y;
            addChild(_loadBar);
            var params:Object = {
                limit: _requestCount,
                skip: _userList.dataProvider.length,
                toDate:_toDate,
                period:_period
            };
            if(_countryButton.isSelected){
                params.country = true;
            }
            dispatchEvent(new Event(ChallengeEvent.REQUEST_LEADER_BOARD_DATA, false, params));
        }
    }

    private function createShowBySection():void{
        showByBorderList = [];
        var border:Quad;
        showByLabel = {};
        showByLabel[RequestPeriod.THIS_WEEK] = "This week";
        showByLabel[RequestPeriod.THIS_MONTH] = "This month";
        showByLabel[RequestPeriod.THIS_YEAR] = "This year";
        showByLabel[RequestPeriod.ALL] = "Show all";

        _showByButton.addEventListener(Event.CHANGE, showByChangeHandler);
        border = createBorder();
        showByBorderList.push(border);
        border.height = _showByButton.defaultSkin.height;

        border = createBorder();
        showByBorderList.push(border);
        border.height = _showByButton.defaultSkin.height;

        showByMenu = new Sprite();
        var menuBackground:Image = new Image(ButtonFactory.assetManager.getTexture("menu_background"));
        menuBackground.scale9Grid = new Rectangle(menuBackground.width/3, menuBackground.height/3, menuBackground.width/3, menuBackground.height/3);
        menuBackground.width = _showByButton.width;
        menuBackground.height = 190;
        menuBackground.filter = new DropShadowFilter(2, Math.PI/4, 0, 0.2);
        menuBackground.y = -1;

        var menuTopBorder:Quad = new Quad( 1, 1, 0xFFFFFF);
        menuTopBorder.width = menuBackground.width - 2;
        menuTopBorder.height = 5;
        menuTopBorder.x = 1;
        menuTopBorder.y = -2;

        showByMenu.addChild(menuBackground);
        showByMenu.addChild(menuTopBorder);

        showByGroup = new LayoutGroup();
        var layout:VerticalLayout = new VerticalLayout();
        layout.gap = 5;
        layout.paddingLeft = layout.paddingRight = 5;
        layout.paddingTop = 6;
        showByGroup.layout = layout;
        showByToggleGroup = new ToggleGroup();

        var radio:Radio;
        _period = RequestPeriod.THIS_WEEK;

        radio = createRadio(showByLabel[RequestPeriod.THIS_WEEK], RequestPeriod.THIS_WEEK);
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.THIS_WEEK){
            showByToggleGroup.selectedItem = radio;
        }

        radio = createRadio(showByLabel[RequestPeriod.THIS_MONTH], RequestPeriod.THIS_MONTH);
        showByGroup.addChild(createRadioBorder());
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.THIS_MONTH){
            showByToggleGroup.selectedItem = radio;
        }

        radio = createRadio(showByLabel[RequestPeriod.THIS_YEAR], RequestPeriod.THIS_YEAR);
        showByGroup.addChild(createRadioBorder());
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.THIS_YEAR){
            showByToggleGroup.selectedItem = radio;
        }


        radio = createRadio(showByLabel[RequestPeriod.ALL], RequestPeriod.ALL);
        showByGroup.addChild(createRadioBorder());
        showByGroup.addChild(radio);
        showByToggleGroup.addItem(radio);
        if(_period == RequestPeriod.ALL){
            showByToggleGroup.selectedItem = radio;
        }

        showByGroup.validate();
        menuBackground.height = showByGroup.height + 5;

        showByMenu.addChild(showByGroup);
        addChild(showByMenu);
        showByMenu.visible = false;
        showByToggleGroup.addEventListener(Event.CHANGE, showByGroupChangeHandler);
    }

    private function showByGroupChangeHandler(event:Event):void {
        _period = showByToggleGroup.selectedItem.name;
        _showByButton.label = showByLabel[_period];
        showByMenu.visible = _showByButton.isSelected = false;

        _userList.dataProvider.removeAll();
        isLoaded = isLoading = false;
        requestData();
    }

    private function showByChangeHandler(event:Event):void {
        showByMenu.x = _showByButton.x;
        showByMenu.y = _regionButtonGroup.y + _regionButtonGroup.height;
        showByMenu.parent.setChildIndex(showByMenu, showByMenu.parent.numChildren-1);
        showByMenu.visible = _showByButton.isSelected;
    }

    private static function createBorder():Quad{
        var border:Quad = new Quad(1, 1, 0xCCCCCC);
        border.width = 1;
        return border;
    }

    private static function createRadioBorder():Quad{
        var border:Quad = new Quad(1, 1, 0xCCCCCC);
        border.height = 1;
        border.width = 85;
        return border;
    }

    private static function createRadio(label:String, value:String):Radio{
        var radio:Radio = new Radio();
        var defaultIcon:Image = new Image(ButtonFactory.assetManager.getTexture("gallery_radio_default"));
        defaultIcon.scale = ButtonFactory.assetManager.scaleFactor/2;
        defaultIcon.color = 0x888888;

        var selectedIcon:Image = new Image(ButtonFactory.assetManager.getTexture("gallery_radio_selected"));
        selectedIcon.scale = ButtonFactory.assetManager.scaleFactor/2;
        selectedIcon.color = 0x026edc;

        radio.defaultIcon = defaultIcon;
        radio.defaultSelectedIcon = selectedIcon;
        radio.labelFactory = GalleryLabelFactory.showByRadioDefaultLabel;
        radio.labelOffsetX = 5;
        radio.iconOffsetY = 1;
        radio.label = label;
        radio.name = value;
        radio.paddingTop = -2;
        radio.paddingBottom = 2;
        return radio;
    }

    public function loadData(data:Array):void {
        if(!data){
            return;
        }
        isLoaded = (data.length < _requestCount);
        for(var i:int = data.length-1;  i >= 0; i--){
            data[i].user = new User(data[i].user);
            if(_userIdList.hasOwnProperty(data[i].user.id)){

            }else{
                _userIdList[data[i].user.id] = true;
            }
        }
        var scrollToBottom:Boolean = false;
        if(_userList.dataProvider){
            scrollToBottom = _userList.dataProvider.length>0;
            _userList.dataProvider.addAll(new ListCollection(data));
        }else{
            _userList.dataProvider = new ListCollection(data);
        }
        if(scrollToBottom){
            _userList.removeEventListener(Event.SCROLL, listScrollHandler);
            _userList.scrollToPosition(0, _userList.maxVerticalScrollPosition + _userList.pageHeight, 1);
            Starling.juggler.delayCall(function ():void {
                _userList.addEventListener(Event.SCROLL, listScrollHandler);
            }, 0.01);
        }
        if(_loadBar){
            _loadBar.removeFromParent();
        }
        isLoading = false;
    }

    private function scrollCompleteHandler(event:Event):void{
        _userList.removeEventListener(FeathersEventType.SCROLL_COMPLETE, scrollCompleteHandler);
        Starling.juggler.delayCall(function ():void {
            _userList.addEventListener(Event.SCROLL, listScrollHandler);
        }, 0.1);
    }
}
}
